! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program check_catprep
! Tests catprep output file for given test input, link with cFITSIO
! Revised 2012 March 5 CGP for version 0.3 of catprep, with USNO data first
use errorhandling
implicit none
character(len=*), parameter :: infile = "testdata/catextract_obs0005010301.fits"
integer :: unit, status, hdu, hdutype, errors, nrows
integer, parameter :: rows_expected(2:4) = (/ 1391, 239, 6569 /)
!
status = 0
errors = 0
call ftgiou(unit, status)
call ftnopn(unit, infile, 0, status)
if(status /= 0) then
   write(*,*)'Could not open file ', trim(infile), ' status=',status
   call error('test_failed', 'could not open file')
end if
do hdu = 2,4
   call ftmahd(unit, hdu, hdutype, status)
   call ftgnrw(unit, nrows, status)
   if(nrows /= rows_expected(hdu)) then
      write(*,*)'HDU', hdu, 'should have', rows_expected(hdu), 'found', nrows
      call error('test_failed', 'wrong number of rows')
      EXIT
   end if
end do

end program check_catprep
